#pragma once

class MemoryRenderer : public CBaseVideoRenderer, public IMemoryRenderer
{
public:
	MemoryRenderer( LPCTSTR tszName, LPUNKNOWN pUnknown, HRESULT *phr );
	virtual ~MemoryRenderer();

	// IUnknown ̃C^[tF[X`
	DECLARE_IUNKNOWN;

	// CUnknown ̃I[o[Ch`
	STDMETHODIMP NonDelegatingQueryInterface( REFIID riid, void **ppv );

	// IMemoryRenderer ̃C^[tF[X`
	STDMETHODIMP GetWidth( long* pWidth ) { *pWidth = this->nWidth; return S_OK; }
	STDMETHODIMP GetHeight( long* pHeight ) { *pHeight = this->nHeight; return S_OK; }
	STDMETHODIMP GetBufferSize( long *pBufferSize) { *pBufferSize = this->nBufferSize; return S_OK; }
	STDMETHODIMP GetCurrentBuffer( byte* pBuffer, long nBufferSize ); 

protected:
	// override CBaseRenderer
	virtual HRESULT DoRenderSample( IMediaSample *pMediaSample );
	virtual HRESULT CheckMediaType( const CMediaType *pMediaType );
	virtual HRESULT SetMediaType( const CMediaType *pMediaType );

private:
	long	nWidth;
	long	nHeight;
	long	nBufferSize;
	void*	pBuffer;
	MemoryRendererInputPin	inputPin;			// ̓s
	CComPtr<IMediaSample>	pLatestSample;		// Ō̃Tv
	CCritSec				latestSampleLock;	// Tv̔rp
	GUID	guidCennected;
	bool	bFoundMediaType;

	HRESULT Grab( IMediaSample* pSample, long nBufferSize, void* pBuffer );
};